clear all
close all
clc

% Datos de la tabla
aditivo = (0:8)';
t_secado = [12;
            10.5;
            10.0;
            8;
            7;
            8;
            7.5;
            8.5;
            9;];

% Matriz A asociada al problema. La parte derecha del sistema serian los
% elementos de t_secado
A = [aditivo.^2, aditivo, ones(size(aditivo))];
b = t_secado;

% Notar que la matriz R no es de nxn, si no que de mxn, por eso se reduce a
% una de 3x3 (cantidad de variables del sistema). Alternativamente, se
% puede utilizar [Q, R] = qr(A, 0), donde R seria de nxn
[Q, R] = qr(A);
R1 = R(1:3, 1:3);

% Matriz del sistema de ecuaciones normales
B = A'*A;

% Numeros de condicion de la matriz
cond(R1)
cond(B)

% Solucion utilizando factorizacion QR (deducir)
c = R\(Q'*b);

% Crear 100 puntos equiespaciados entre 0 y 8
x = linspace(0, 8);

% El modelo es un polinomio de la forma ax^2 + bx + c, puede utilizarse
% polyval para evaluarlo en los puntos creados
plot(aditivo, t_secado, 'or', x, polyval(c, x), 'b');

% Minimo (vertice de la parabola, o dp/dx = 0...
ad_min = -c(2) / (2*c(1));
t_min = polyval(c, ad_min);


