clear all
close all
clc

% 2.1
% Aplicando operaciones matematicas
% 1/n = 1/n0 + alpha*t

% 2.2
% Datos de la tabla
t = (0:10)';
n = [5.03;
    4.71;
    4.40;
    3.97;
    3.88;
    3.62;
    3.30;
    3.15;
    3.08;
    2.92;
    2.70;];

A = [ones(size(t)), t];
b = 1./n;

coef = A\b;

% Mirar el sistema que estamos resolviendo (despejamos los coeficientes
% reales a partir de los obtenidos en nuestra linealizacion del modelo.
n0 = 1/coef(1);
alpha = coef(2);

% 2.3
% Creamos el vector pedido y evaluamos el modelo obtenido.
tt = linspace(0, 10, 110);
nn = n0 ./ (1 + n0*alpha*tt);

% Graficar
plot(t, n, 'or', tt, nn, 'b')
ylabel('x10^{-4}')
xlabel('Tiempo [seg]')
title('Concentracion de Iones')
grid on

