clear all
close all
clc

% Datos de la tabla.
x = [1, 2, 5, 15, 25, 30, 35, 40]';
y = [99, 95, 85, 55, 30, 24, 20, 15]';

% Linealizamos modelo 1
% log(y1) = log(alpha) + x*log(beta)
% Linealizamos modelo 2
% log(y2 / (100 - x)) = log(alpha) + beta*x*log(10)

% 3.1

% Modelo 1
A1 = [ones(size(x)), x];
b1 = log(y);
coef1 = A1\b1;
alfa1 = exp(coef1(1));
beta1 = exp(coef1(2));
fprintf('Modelo 1: alfa = %.4f beta = %.4f\n', alfa1, beta1);

% Midelo 2
A2 = [ones(size(x)), x];
b2 = log(y ./ (100 - x));
coef2 = A2 \ b2;
alfa2 = exp(coef2(1));
beta2 = coef2(2) / log(10);
fprintf('Modelo 2: alfa = %.4f beta = %.4f\n', alfa2, beta2);

% 3.2 Calcular errores obtenidos en cada modelo y mostrarlos en consola
fprintf('Error modelo 1: %f\n', norm(b1 - A1*coef1))
fprintf('Error modelo 2: %f\n', norm(b2 - A2*coef2))

% 3.3 Evaluar ambos modelos en 200 puntos desde 1 a 40.
xx = linspace(1, 40, 200);
y1 = alfa1 * beta1.^(xx);
y2 = alfa2 * (100 - xx).*10.^(beta2*xx);

plot(x, y, 'ok', xx, y1, 'r', xx, y2, 'b')
legend('Puntos', 'Modelo 1', 'Modelo 2')
xlabel('Miles de Millas Recorridas')
ylabel('Porcentaje Util')

% Utilizando el "mejor" modelo, calculamos las estimaciones pedidas
estimaciones = alfa1 * beta1.^([45, 50]);
disp('Las estimaciones pedidas son:')
disp(estimaciones)