clear all
close all
clc

% Datos de la tabla
dosis = [0.25, 1, 1.5, 2.5, 7.5]';
aumento = [-10.8, 13.5, 16.4, 28.7, 51.3]';

% Sistema de ecuaciones asociado al problema
A = [ones(size(dosis)), log10(dosis)];
coef = A \ aumento;
a = coef(1);
b = coef(2);

% Crear vector de 100 elementos y evaluar el modelo obtenido
d = linspace(0.25, 7.5, 100);
aum = a + b*log10(d);

% Graficar
plot(dosis, aumento, 'or', d, aum, 'b')
grid on
xlabel('Dosis de vitamina')
ylabel('Aumento de peso')

% Reemplazando por 0 y despejando la ecuacion:
dosis_no = 10^(-a/b);
fprintf('Para no aumentar de peso, la dosis requerida es: %f\n', dosis_no)